<template>
        <div class="mask d-flex align-items-center h-100 gradient-custom-3">
            <div class="container h-100">
                <div class="row d-flex justify-content-center h-100">
                    <div class="col-12 col-md-9 col-lg-7 col-xl-6">
                        <div class="card" style="border-radius: 15px;">
                            <div class="card-body p-5">
                                <h2 class="text-uppercase text-center mb-5">Увійти</h2>

                                <form @submit.prevent="sendCredentials">

                                    <div class="form-outline mb-4">
                                        <input type="text"
                                               v-model="details.name"
                                               id="name"
                                               class="form-control form-control-lg"
                                               :class="{'error-border error-text': this.nameErrors.length > 0}"
                                        />
                                        <label class="form-label" for="name">Your Name</label>
                                        <br>
                                        <span v-if="nameErrors"
                                              :class="{'error-text': this.nameErrors.length > 0}"
                                        >{{ nameErrors[0] }}</span>
                                    </div>

                                    <div class="form-outline mb-4">
                                        <input type="email"
                                               v-model="details.email"
                                               id="email"
                                               class="form-control form-control-lg"
                                               :class="{'error-border error-text': this.emailErrors.length > 0}"
                                        />
                                        <label class="form-label" for="email">Your Email</label>
                                        <br>
                                        <span v-if="emailErrors"
                                              :class="{'error-text': this.emailErrors.length > 0}"
                                        >{{ emailErrors[0] }}</span>
                                    </div>

                                    <div class="form-outline mb-4">
                                        <input type="password"
                                               v-model="details.password"
                                               id="password"
                                               class="form-control form-control-lg"
                                               :class="{'error-border error-text': this.passwordErrors.length > 0}"
                                        />
                                        <label class="form-label" for="password">Password</label>
                                        <br>
                                        <span v-if="passwordErrors"
                                              :class="{'error-text': this.passwordErrors.length > 0}"
                                        >{{ passwordErrors[0] }}</span>
                                    </div>

                                    <div v-if="!user">
                                        <div class="checkbox mb-3">
                                            <label>
                                                <span v-if="signIn" @click="signIn = !signIn" class="signIn text-decoration-underline"> Змінити</span>
                                                <span v-else @click="signIn = !signIn" class="signIn text-decoration-underline"> Змінити </span>
                                            </label>
                                        </div>
                                        <button v-if="signIn" class="w-100 btn btn-lg btn-primary"> Увійти </button>
                                        <button v-else class="w-100 btn btn-lg btn-primary"> Зареєструватися </button>
                                    </div>

                                    <div v-else>
                                        <button class="w-100 btn btn-lg btn-primary"> Вийти </button>
                                    </div>
                                </form>

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</template>

<script>
import {mapActions, mapGetters, mapMutations} from 'vuex';
import authValidationMixin from "@/mixins/authValidationMixin.js";

export default {
    name: 'Auth',
    mixins: [authValidationMixin],
    data() {
        return {
            details: {
                name: "test1",
                email: "test1@gmail.com",
                password: "12345678",
            },
            signIn: true,
            user_id: 0,
        };
    },
    computed: {
        ...mapGetters(["errors"]),
        ...mapGetters("auth", ["user", "apiToken"]),
    },
    mounted() {
        this.setErrors({});
    },
    methods: {
        ...mapMutations(["setErrors"]),
        ...mapActions("auth", ["sendLoginRequest", "sendRegisterRequest", "sendLogoutRequest"]),
        sendCredentials() {
            console.log(this.user);
            if(this.user) {
                this.sendLogoutRequest();
            } else {
                if (this.signIn) {
                    this.sendLoginRequest(this.details);
                } else {
                    this.sendRegisterRequest(this.details);
                }
            }
        },
    },

}
</script>
<style lang="scss" scoped>
.my-form{
    margin-top: 10px;
}

.error {
    &-border {
        border: 1px solid red;
    }
    &-text {
        color: red;
    }
}

.disabled-button {
    disabled: "disabled";
}
</style>
